-- Sanity checks of mission designer
assert(mist ~= nil, "\n\n** HEY MISSION-DESIGNER! **\n\nMiST has not been loaded!\n\nMake sure MiST 4.0.57 or higher is running\n*before* running this script!\n")

cadets_list = {}

function init_ballast()	
	local tmp = {}
	tmp['mass'] = 0
	return tmp
end

function init_cadet()
	local tmp = {}
	return tmp
end

function correct_angle(angle) --Перевод угла в диапазон 0:2pi (0:360)
	if angle < 0 then 
		angle = angle + 2*math.pi
	elseif angle > 2*math.pi then
		angle = angle - 2*math.pi
	end
	return angle
end

function getDistance(point1, point2) --Расстояние между точками на плоскости
    return math.sqrt((point2.x - point1.x)^2 + (point2.z - point1.z)^2)
end

function get_intermediate_WP(point1, point2, dist)
	local k = 3000 / dist -- 3000 Дистанция корретировки в метрах
	local tmp_Point
	tmp_Point.x = point1.x + (point2.x - point1.x) * k
	tmp_Point.z = point1.z + (point2.z - point1.z) * k
	return tmp_Point
end

function getFlatAngle(point1, point2) --Курс между точками
	local VectorX = point2.x - point1.x
	local VectorZ = point2.z - point1.z
    --return math.acos(VectorX / math.sqrt(VectorX^2+VectorZ^2))
	return correct_angle(math.atan2(VectorZ, VectorX))
end

function h_speed(unit)
    local vec = unit:getVelocity()
    return math.sqrt(vec.x ^ 2 + vec.z ^ 2) * 3.6
end

function getDistance(point1, point2) --Расстояние между точками на плоскости
    return math.sqrt((point2.x - point1.x)^2 + (point2.z - point1.z)^2)
end

function round(num, numDecimalPlaces) --Функция округления
  local mult = 10^(numDecimalPlaces or 0)
  return math.floor(num * mult + 0.5) / mult
end

function getHeliSpeed(heli)
	local Velocity = heli:getVelocity()
	--math.sqrt((Velocity.x^2) + (Velocity.y^2) + (Velocity.z^2))
	return math.sqrt(Velocity.x^2 + Velocity.z^2) -- Без учета вертикальной скорости
end

function check_distance_interval(arg)
	local leader = arg[1]
	local wingman = arg[2]
	local groupid = arg[3]
		
	timer.scheduleFunction(function (arg, time)		
		local leader = arg[1]
		local wingman = arg[2]
		local groupid = arg[3]

		if not leader:isExist() then		
			trigger.action.outTextForGroup(groupid, 'Не существует лидера.', 10)
			return nil
			end
			
		if not wingman:isExist() then		
			return nil
			end			
		
		--local speed = getHeliSpeed(leader)	-- Скорость ведущего	
		local length = getDistance(wingman:getPoint(), leader:getPoint()) -- Дистанция до ведущего

		local w_angle = math.deg(getFlatAngle(leader:getPoint(), wingman:getPoint())) -- Угол от ведущего к ведомому
		local l_angle = mist.utils.toDegree(mist.getHeading(leader, true)) + 180 -- Угол от ведущего к ведомому относительно обратного курса
		if l_angle > 360 then
			l_angle = l_angle - 360
			end			
		local max_angle = math.max(math.abs(w_angle),math.abs(l_angle))
		local min_angle = math.min(math.abs(w_angle),math.abs(l_angle))
		local angle = max_angle - min_angle -- Разность углов для определения пеленга
		-- Дистанция и интервал работают не корректно
		--local D = math.acos(math.rad(angle))* length -- Дистанция
		--local I = math.asin(math.rad(angle))* length -- Интервал
		local dH = wingman:getPoint().y - leader:getPoint().y -- Разность высот
		--local C = math.deg(getFlatAngle(leader:getPoint(), wingman:getPoint())) -- Курс на ведущего

		if length > 900 then
			trigger.action.outTextForGroup(groupid, 'Дистанция больше 900 м.', 10)
			return nil
			end	
			
		length = round(length, 1)
		trigger.action.outTextForGroup(groupid, 'D = ' .. tostring(round(length, 1)) .. ' м. A = ' .. tostring(round(angle,0)) .. '°. dH = ' .. tostring(round(dH,0)) .. ' м.', 2)
		return time + 3
	end, {leader, wingman, groupid}, timer.getTime() + 3)
	
end

function do_Smoke(arg)
	local heli = arg[1]
	local color = arg[2]
	trigger.action.ctfColorTag(heli:getName() , color , 1)
end

function get_nearest_units(arg)
	local heli = arg[1]
	local groupid = arg[2]
	local name = heli:getName()
	local cnt = 0
	missionCommands.removeItemForGroup(groupid , {'Упражнения', 'Пеленг', 'Выбрать борт'})	
	missionCommands.addSubMenuForGroup(groupid, 'Выбрать борт', {'Упражнения', 'Пеленг'})
	
	local ifFound = function(foundItem)
		local fi_name = foundItem:getName()
		local fi_group = foundItem:getGroup()
		local fi_groupid =	fi_group:getID()
		local fi_g_name = fi_group:getName()
		--trigger.action.outTextForGroup(groupid, fi_name .. '  ' .. name, 10)
		if fi_name ~= name then
			cnt = cnt + 1
			trigger.action.outTextForGroup(groupid, 'Найден ' .. fi_name, 10)
			missionCommands.addCommandForGroup(groupid, fi_name, {'Упражнения', 'Пеленг', 'Выбрать борт'}, check_distance_interval, {foundItem, heli, groupid})
		end		
		return true
	end
	
	local volS = {
		id = world.VolumeType.SPHERE,
		params = {
			point = heli:getPoint(),
			radius = 900
		}
	}	
	-- Object.Category.UNIT, Object.Category.STATIC, Object.Category.SCENERY, Object.Category.WEAPON, Object.Category.CARGO
	world.searchObjects( {Object.Category.UNIT}, volS, ifFound )
	if cnt == 0 then
		trigger.action.outTextForGroup(groupid, 'Поблизости нет бортов.', 10)
	end
	if cnt > 0 then
		trigger.action.outTextForGroup(groupid, 'Чтобы остановить скрипт разорви дистанцию более 900 м.', 10)
	end	
end	

function my_func(arg)	
	local heli = arg[1]
	local GROUPID = arg[2]
	local LIMIT_TIME = 780 -- Время на выполнение упражнения в секундах
	local TOTAL_TIME = timer.getTime() -- Общее время
	local MOVE_FLAG = false -- Флаг начала разгона
	local S_POINT = heli:getPoint() -- Точка взлета
	trigger.action.outTextForGroup(GROUPID, 'Начинайте разгон.', 10)

	timer.scheduleFunction(function (arg, time)
		local heli = arg[1]
		local now = 0
		if not heli:isExist() then
			return nil
			end
		local point = heli:getPoint()
		local rt_digit = 0
		local rt_decim = 0
		if getDistance(point, S_POINT) > 7000 then
			trigger.action.outTextForGroup(GROUPID, 'Вы покинули зону полетов.', 10)
			return nil
			end
		if getDistance(point, S_POINT) > 3 then
			MOVE_FLAG = true
			end
		
		if MOVE_FLAG then
			now = timer.getTime() - TOTAL_TIME
			rt_digit, rt_decim = math.modf(now/60)
			rt_decim, _ = now - rt_digit*60

			if (not heli:inAir()) or now > LIMIT_TIME then
				trigger.action.outTextForGroup(GROUPID, string.format("Таймер = %2d:%2d мин.", rt_digit, rt_decim), 10)
				return nil
			else
				trigger.action.outTextForGroup(GROUPID, string.format("Таймер = %2d:%2d мин.", rt_digit, rt_decim), 1)			
			end
			
			end						
		return time + 1
	end, {heli}, timer.getTime() + 1)
end

function add_Ballast(arg)
	local heli = arg[1]
	local cadet = heli:getName()
	local groupid = arg[2]
	local mass = arg[3]
	cadets_list[cadet]['mass'] = cadets_list[cadet]['mass'] + mass
	trigger.action.outTextForGroup(groupid, 'Ваш балласт ' .. cadets_list[cadet]['mass'] .. ' кг.', 10);
	trigger.action.setUnitInternalCargo(cadet, cadets_list[cadet]['mass'] )
	return
end

function remove_Ballast(arg)
	local heli = arg[1]
	local cadet = heli:getName()
	local groupid = arg[2]
	local mass = arg[3]	
	cadets_list[cadet]['mass'] = 0
	trigger.action.outTextForGroup(groupid, 'Балласт выгружен.', 10);
	trigger.action.setUnitInternalCargo(cadet, cadets_list[cadet]['mass'])
	return
end

function exercise_Hover(arg)
	local heli = arg[1]
	local HELI_TYPE = heli:getTypeName()
	if HELI_TYPE == 'Mi-8MT' then
		HELI_HEIGHT = 2.2
	elseif HELI_TYPE =='Mi-24P' or HELI_TYPE =='Ka-50' then
		HELI_HEIGHT = 1.8
	elseif HELI_TYPE == 'UH-1H' then
		HELI_HEIGHT = 1.6
	else
		HELI_HEIGHT = 1.6
	end
	local HOVER_TIME = 20 -- Время висения в секундах
	local GROUPID = arg[2] -- Идентификатор вертолета
	local TOP_HEIGHT = arg[3] -- Высота висения	
	local LIMIT_TIME = 300 -- Время на выполнение упражнения в секундах
	local TOTAL_TIME = timer.getTime() -- Общее время
	local TEST_TIME = nil -- Счетчик времени висения
	local ESTIMATION = 5 -- Оценка
	local S_POINT = heli:getPoint(); -- Точка взлета
	local HOVER_FLAG = false -- Флаг взлета	
	local S_ANGLE = mist.utils.toDegree(mist.getHeading(heli, true))
	trigger.action.outTextForGroup(GROUPID, 'Поднимайтесь на высоту ' .. TOP_HEIGHT .. ' м.' , 10)
	--trigger.action.outSoundForGroup(GROUPID, "take_off.ogg")
	timer.scheduleFunction(function (arg, time)
		--local _statusL, _eventLand = pcall(function() return {initiator = event.initiator, place = event.place; } end);			
		--if not _statusL  then 
		--	env.warning('Не удается получить данные при посадке', false);
		--else
		local heli = arg[1]
		if not heli:isExist() then
			return nil
			end
		local point = heli:getPoint()
		local height = point.y - land.getHeight({x = point.x, y = point.z})
		local now = timer.getTime() - TOTAL_TIME		
		test_time = 0
		
		if height >= TOP_HEIGHT and (not HOVER_FLAG) then
			HOVER_FLAG = true
			TEST_TIME = timer.getTime()
			trigger.action.outTextForGroup(GROUPID, 'Удерживайте высоту ' .. TOP_HEIGHT .. ' м.' , 10)
			--trigger.action.outSoundForGroup(GROUPID, "hover.ogg")
			end	
			
		if HOVER_FLAG then 
			test_time = timer.getTime() - TEST_TIME
			if test_time < HOVER_TIME then 		
				local diff_Ver = math.abs (TOP_HEIGHT - height)
				if (diff_Ver > 1.1) and ESTIMATION > 4 then
					ESTIMATION = 4
					trigger.action.outTextForGroup(GROUPID, 'Разброс высоты более 1 м.' , 3)
					end		
				if (diff_Ver > 2.1) and ESTIMATION > 3 then
					ESTIMATION = 3
					trigger.action.outTextForGroup(GROUPID, 'Разброс высоты более 2 м.' , 3)
					end		
				if (diff_Ver > 3.1) and ESTIMATION > 2 then
					ESTIMATION = 2
					trigger.action.outTextForGroup(GROUPID, 'Разброс высоты более 3 м.' , 3)
					end
			elseif test_time == HOVER_TIME then 
				trigger.action.outTextForGroup(GROUPID, 'Совершите посадку.', 10)
				--trigger.action.outSoundForGroup(GROUPID, "landing.ogg")
			end
		end
		
		if (HOVER_FLAG and (not heli:inAir())) or now > LIMIT_TIME then
			trigger.action.outTextForGroup(GROUPID, 'Ваша оценка ' .. ESTIMATION .. ', время выполнения упражнения ' .. now .. ' c.', 10)
			if ESTIMATION > 2 then
				trigger.action.outText(heli:getPlayerName() .. ' : - "Контрольное на ' .. TOP_HEIGHT ..'м. норма."', 10)		
			end
			return nil
		end
		
		local diff_Hor = mist.utils.get2DDist(S_POINT, point)
		if diff_Hor > 25 then
			trigger.action.outTextForGroup(GROUPID, 'Вы покинули зону висения, упражнение прервано.', 10)
			return nil
			end
		if (diff_Hor > 3.1) and ESTIMATION > 4 then --if (diff_Hor > 2.1) and ESTIMATION > 4 then 
			ESTIMATION = 4
			trigger.action.outTextForGroup(GROUPID, 'Смещение больше 2 м.' , 3)
			end		
		if (diff_Hor > 4.1) and ESTIMATION > 3 then --if (diff_Hor > 3.1) and ESTIMATION > 3 then 
			ESTIMATION = 3
			trigger.action.outTextForGroup(GROUPID, 'Смещение больше 3 м.' , 3)
			end		
		if (diff_Hor > 6.1) and ESTIMATION > 2 then --if (diff_Hor > 5.1) and ESTIMATION > 2 then 
			ESTIMATION = 2
			trigger.action.outTextForGroup(GROUPID, 'Смещение больше 5 м.' , 3)
			end
		
		local ver_speed = heli:getVelocity().y
		local offset = 0.5
		
		
		if (height > 20) and (height < 30) then
			if (ver_speed < -3.1) then 
				ESTIMATION = 2
				trigger.action.outTextForGroup(GROUPID, 'Скорость снижения на высоте от 20 до 30 м более 3 м/с.' , 3)
			end	
		end
		if (height > 10) and (height < 20) then
			if (ver_speed < -2.1) then 
				ESTIMATION = 2
				trigger.action.outTextForGroup(GROUPID, 'Скорость снижения на высоте от 10 до 20 м более 2 м/с.' , 3)
			end	
		end
		
		if (height > HELI_HEIGHT + offset) and (height < 10) then
			if (ver_speed < -1.51) then 
				ESTIMATION = 2
				trigger.action.outTextForGroup(GROUPID, 'Скорость снижения на высоте от земли до 10 м более 1.5 м/с.' , 3)
			end	
		end
		
		if (height < HELI_HEIGHT + offset) then
			if (ver_speed < -0.21) then 
				ESTIMATION = 2
				trigger.action.outTextForGroup(GROUPID, 'Скорость снижения при приземлении более 0.2 м/с.' , 3)
			end	
		end	
		
		local angle = mist.utils.toDegree(mist.getHeading(heli, true))
		local diff_Ang = math.abs (S_ANGLE - angle)
		
		if (diff_Ang > 6.1) and ESTIMATION > 4 then --if (diff_Ang > 5.1) and ESTIMATION > 4 then
			ESTIMATION = 4
			trigger.action.outTextForGroup(GROUPID, 'Отклонение от курса более 5 градусов.' , 3)
			end		
		if (diff_Ang > 8.1) and ESTIMATION > 3 then --if (diff_Ang > 7.1) and ESTIMATION > 3 then 
			ESTIMATION = 3
			trigger.action.outTextForGroup(GROUPID, 'Отклонение от курса более 7 градусов.' , 3)
			end		
		if (diff_Ang > 11.1) and ESTIMATION > 2 then --if (diff_Ang > 10.1) and ESTIMATION > 2 then 
			ESTIMATION = 2
			trigger.action.outTextForGroup(GROUPID, 'Отклонение от курса более 10 градусов.' , 3)
			end	
			
		--trigger.action.outText( string.format('Total %.0f', now) .. ' s, hover ' .. string.format('%.0f', test_time) .. ' s, alt ' .. string.format('%.1f', height) .. ' m, dist ' .. string.format('%.1f', getDistance(S_POINT, point)) .. ' m, V ' .. string.format('%.1f', heli:getVelocity().y) .. ' m/s' .. ' dir ' .. string.format('%.1f', angle), 10);				

		return time + 1
		
	end, {heli}, timer.getTime() + 1)
end	

local customEventHandler = {};
function customEventHandler:onEvent(event)
	if world.event.S_EVENT_ENGINE_STARTUP == event.id then
		--trigger.action.outText('Player_Enter_VI', 3)		
		local heli = event.initiator
		local cadet = heli:getName()
		local group = heli:getGroup()
		local groupID =	group:getID()
		if cadets_list[cadet] == nil then
			
			--trigger.action.outText('init_VI_Command for ' .. cadet, 3)
			
			--cadets_list[cadet] = cadet		
			cadets_list[cadet] = init_cadet()
			if cadets_list[cadet]['mass'] == nil then
				cadets_list[cadet]['mass'] = init_ballast()
				end		
			remove_Ballast({heli,  groupID, 0})
			
			missionCommands.addSubMenuForGroup(groupID, 'Упражнения')			
			
			missionCommands.addSubMenuForGroup(groupID, 'Висение', {'Упражнения'})
			missionCommands.addSubMenuForGroup(groupID, 'Пеленг', {'Упражнения'})
			missionCommands.addSubMenuForGroup(groupID, 'Пилотажный дым', {'Упражнения'})
			missionCommands.addSubMenuForGroup(groupID, 'Полет по кругу', {'Упражнения'})
			missionCommands.addSubMenuForGroup(groupID, 'Балласт', {'Упражнения'})
			
			
			missionCommands.addCommandForGroup(groupID, 'На  5 м', {'Упражнения', 'Висение'} , exercise_Hover, {heli, groupID,  5})
			missionCommands.addCommandForGroup(groupID, 'На 10 м', {'Упражнения', 'Висение'} , exercise_Hover, {heli, groupID, 10})
			missionCommands.addCommandForGroup(groupID, 'На 15 м', {'Упражнения', 'Висение'} , exercise_Hover, {heli, groupID, 15})
			missionCommands.addCommandForGroup(groupID, 'На 20 м', {'Упражнения', 'Висение'} , exercise_Hover, {heli, groupID, 20})
			missionCommands.addCommandForGroup(groupID, 'На 30 м', {'Упражнения', 'Висение'} , exercise_Hover, {heli, groupID, 30})
			
			missionCommands.addCommandForGroup(groupID, 'Список бортов', {'Упражнения', 'Пеленг'} , get_nearest_units, {heli, groupID})
			missionCommands.addSubMenuForGroup(groupID, 'Выбрать борт', {'Упражнения', 'Пеленг'})
			
			missionCommands.addCommandForGroup(groupID, 'Зеленый', {'Упражнения', 'Пилотажный дым'}, do_Smoke, {heli,  1})
			missionCommands.addCommandForGroup(groupID, 'Красный', {'Упражнения', 'Пилотажный дым'}, do_Smoke, {heli,  2})
			missionCommands.addCommandForGroup(groupID, 'Белый', {'Упражнения', 'Пилотажный дым'}, do_Smoke, {heli,  3})
			missionCommands.addCommandForGroup(groupID, 'Оранжевый', {'Упражнения', 'Пилотажный дым'}, do_Smoke, {heli,  4})
			missionCommands.addCommandForGroup(groupID, 'Синий', {'Упражнения', 'Пилотажный дым'}, do_Smoke, {heli,  5})
			missionCommands.addCommandForGroup(groupID, 'Прекратить', {'Упражнения', 'Пилотажный дым'}, do_Smoke, {heli,  0})
			
			missionCommands.addCommandForGroup(groupID, 'Активировать секундомер', {'Упражнения', 'Полет по кругу'}, my_func, {heli,  groupID})
			
			missionCommands.addCommandForGroup(groupID, 'Добавить 1000 кг.', {'Упражнения', 'Балласт'}, add_Ballast, {heli,  groupID, 1000})
			missionCommands.addCommandForGroup(groupID, 'Добавить  100 кг.', {'Упражнения', 'Балласт'}, add_Ballast, {heli,  groupID, 100})
			missionCommands.addCommandForGroup(groupID, 'Добавить   10 кг.', {'Упражнения', 'Балласт'}, add_Ballast, {heli,  groupID, 10})
			missionCommands.addCommandForGroup(groupID, 'Выгрузить все', {'Упражнения', 'Балласт'}, remove_Ballast, {heli,  groupID, 0})
		else
			--cadets_list[cadet]['mass'] = init_ballast() -- очищаем значеине балласта
			remove_Ballast({heli,  groupID, 0})
			--trigger.action.outText('reload_VI_Command for ' .. cadet, 3)
			missionCommands.removeItemForGroup(groupID , {'Упражнения', 'Висение'})
			missionCommands.removeItemForGroup(groupID , {'Упражнения', 'Пеленг'})
			missionCommands.removeItemForGroup(groupID , {'Упражнения', 'Пилотажный дым'})
			missionCommands.removeItemForGroup(groupID , {'Упражнения', 'Полет по кругу'})			
			missionCommands.removeItemForGroup(groupID , {'Упражнения', 'Балласт'})
			
			missionCommands.addSubMenuForGroup(groupID, 'Висение', {'Упражнения'})
			missionCommands.addSubMenuForGroup(groupID, 'Пеленг', {'Упражнения'})
			missionCommands.addSubMenuForGroup(groupID, 'Пилотажный дым', {'Упражнения'})
			missionCommands.addSubMenuForGroup(groupID, 'Полет по кругу', {'Упражнения'})
			missionCommands.addSubMenuForGroup(groupID, 'Балласт', {'Упражнения'})
			
			missionCommands.addCommandForGroup(groupID, 'На  5 м', {'Упражнения', 'Висение'} , exercise_Hover, {heli, groupID,  5})
			missionCommands.addCommandForGroup(groupID, 'На 10 м', {'Упражнения', 'Висение'} , exercise_Hover, {heli, groupID, 10})
			missionCommands.addCommandForGroup(groupID, 'На 15 м', {'Упражнения', 'Висение'} , exercise_Hover, {heli, groupID, 15})
			missionCommands.addCommandForGroup(groupID, 'На 20 м', {'Упражнения', 'Висение'} , exercise_Hover, {heli, groupID, 20})
			missionCommands.addCommandForGroup(groupID, 'На 30 м', {'Упражнения', 'Висение'} , exercise_Hover, {heli, groupID, 30})
			
			missionCommands.addCommandForGroup(groupID, 'Список бортов', {'Упражнения', 'Пеленг'} , get_nearest_units, {heli, groupID})
			missionCommands.addSubMenuForGroup(groupID, 'Выбрать борт', {'Упражнения', 'Пеленг'})
			
			missionCommands.addCommandForGroup(groupID, 'Зеленый', {'Упражнения', 'Пилотажный дым'}, do_Smoke, {heli,  1})
			missionCommands.addCommandForGroup(groupID, 'Красный', {'Упражнения', 'Пилотажный дым'}, do_Smoke, {heli,  2})
			missionCommands.addCommandForGroup(groupID, 'Белый', {'Упражнения', 'Пилотажный дым'}, do_Smoke, {heli,  3})
			missionCommands.addCommandForGroup(groupID, 'Оранжевый', {'Упражнения', 'Пилотажный дым'}, do_Smoke, {heli,  4})
			missionCommands.addCommandForGroup(groupID, 'Синий', {'Упражнения', 'Пилотажный дым'}, do_Smoke, {heli,  5})
			missionCommands.addCommandForGroup(groupID, 'Прекратить', {'Упражнения', 'Пилотажный дым'}, do_Smoke, {heli,  0})	

			missionCommands.addCommandForGroup(groupID, 'Активировать секундомер', {'Упражнения', 'Полет по кругу'}, my_func, {heli,  groupID})
			
			missionCommands.addCommandForGroup(groupID, 'Добавить 1000 кг.', {'Упражнения', 'Балласт'}, add_Ballast, {heli,  groupID, 1000})
			missionCommands.addCommandForGroup(groupID, 'Добавить  100 кг.', {'Упражнения', 'Балласт'}, add_Ballast, {heli,  groupID, 100})
			missionCommands.addCommandForGroup(groupID, 'Добавить   10 кг.', {'Упражнения', 'Балласт'}, add_Ballast, {heli,  groupID, 10})
			missionCommands.addCommandForGroup(groupID, 'Выгрузить все', {'Упражнения', 'Балласт'}, remove_Ballast, {heli,  groupID, 0})			
		end			
	end
end;
-- trigger.action.setUnitInternalCargo(event, _minesMass )
world.addEventHandler(customEventHandler);